#!/usr/bin/env python

import bootstrap
import sys
import openpluginlib
import openimagelib
import openmedialib
import jstack
import keygrab

def usage( ):
	print """
jbatch [ options ] [ op ]*

Options:

    -n, --no-key-grab : disable terminal io functionality

Special:

    --help            : this information

Examples:

    To play a media clip:
    $ jbatch <media>

    To play multiple media clips:
    $ jbatch file1.avi play file2.avi play 

    To play a video clip in greyscale:
    $ jbatch <media> greyscale

    To transcode to a specific video format:
    $ jbatch <target>.oml <media> normalise op:<output> encode
    where target is for example film-vcd, pal-vcd, pal-dv, ntsc-dv etc

    To transcode to a specific video format in two pass mode:
    $ jbatch <target>.oml <media> normalise op:<output> pass=1 encode op:<output> pass=2 encode

    To display all defined functions:
    $ jbatch functions

Additional:

    See OML docs.
"""

def main( ):
	ops = [ ]
	key_grab = True

	for i in sys.argv[ 1: ]:
		arg = None

		if i.startswith( "--" ) and i.find( "=" ) > 0:
			i, arg = i.split( "=", 1 )

		if i in ( "-n", "--no-key-grab" ):
			key_grab = False
		elif i in ( "--help" ):
			usage( )
			sys.exit( 0 )
		else:
			arg = i

		if arg is not None:
			ops.append( arg )

	if len( ops ) > 0:
		if key_grab:
			keygrab.init( )
		try:
			rpn = jstack.stack( )
			rpn.push( "jstack.oml" )
			rpn.push_args( ops )
			if not rpn.empty( ): rpn.push( "play" )
		except jstack.stack_exception, e:
			print e
	else:
		usage( )

	openpluginlib.uninit( )

if __name__ == "__main__":
	main( )

