import openpluginlib

def assign_prop( property, name, value ):
	if property is not None and property.valid( ):
		if property.is_a_int( ):
			property.set( int( value ) )
		elif property.is_a_double( ):
			property.set( float( value ) )
		elif property.is_a_wstring( ):
			property.set( str( value ) )
		elif property.is_a_wstring_list( ):
			property.set( value )
	else:
		print "invalid ", name, value

def value_prop( prop ):
	result = None
	if prop is not None and prop.valid( ):
		if prop.is_a_int( ):
			result = str( prop.value_as_int( ) )
		elif prop.is_a_double( ):
			result = str( prop.value_as_double( ) )
		elif prop.is_a_wstring( ):
			result = unicode( prop.value_as_wstring( ) )
		elif prop.is_a_wstring_list( ):
			result = prop.value_as_wstring_list( )
	return result

def find_prop( node, key ):
	if key[ 0 ] == "@":
		split = key[ 1: ].split( "." )
		name = split.pop( )
		for i in split:
			node = node.fetch_slot( int( i ) )
			if node is None: return None
	else:
		name = key
	return node.properties( ).get_property( name )

def update_prop( node, name, value ):
	if node is not None:
		prop = node.properties( ).get_property( name )
		if prop is None or not prop.valid( ):
			prop = openpluginlib.property( openpluginlib.create_key_from_string( name ) )
			node.properties( ).append( prop )
		prop.set( value )

def retrieve_uri( node ):
	uri = None
	if node is not None:
		prop = find_prop( node, "rpn_uri" )
		if prop is not None and prop.valid( ):
			uri = value_prop( prop )
		else:
			uri = node.get_uri( )
	return uri

